package wifky_amazon;

# use strict; use warnings;

$main::preferences{Amazon} = [
    {
      desc => 'Your Amazon associate-ID' ,
      name => 'amazon_associate_id' ,
      size => 20 
    }
];

$main::inline_plugin{'amazon'} = sub {
    my ($session,$itemid) = @_;

    my %tags;
    my $bookinfo=&main::read_object($session->{title},"bookinfo.$itemid");
    if( $bookinfo ){
        %tags = map{ split(/=/,$_,2) } split(/\n/,$bookinfo);
    }else{
        unless( $main::config{amazon_associate_id} ){
            return 'amazon_associate_id not defined';
        }

        eval 'use Encode;';

        my $xml = &http('webservices.amazon.co.jp' ,
              '/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=1YKWYFPHYWMTQ1WKYBG2' .
              '&Operation=ItemLookup&ItemId=' . $itemid .
              '&AssociateTag=' . $main::config{amazon_associate_id} .
              '&ResponseGroup=Small,Images' );
        
        my $text='';
        &parse_xml(
            $xml ,
            sub { 1; } ,
            sub {
                my $tag=shift;
                if( $tag =~ /((Small)|(Medium)|(Large))Image/ ){
                    $tags{ $tag } = join("\t",$tags{'URL'}
                                             ,$tags{'Width'}
                                             ,$tags{'Height'} )
                }else{
                    $tags{ $tag } = $text ;
                }
                $text = '' ;
                1;
            } ,
            sub {
                $text .= shift;
                1;
            }
        );
        if( $tags{IsValid} eq 'True' ){
            if( defined(&Encode::from_to) ){
                Encode::from_to($tags{Title},'utf8','euc-jp');
            }else{
                $tags{Title} = "The Bookimage for $itemid on amazon";
            }
            $tags{DetailPageURL} =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack('C',hex($1))/eg;
            &main::write_object( $session->{title} ,
                                 "bookinfo.$itemid" ,
                                 join("\n",map(
                                    sprintf("%s=%s",$_,$tags{$_}),
                                    qw{
                                        DetailPageURL
                                        Title
                                        SmallImage
                                        MediumImage
                                        LargeImage
                                    }
                                 )));
        }
    }

    if( %tags ){
        sprintf <<FORMAT
<a href="%s"><img alt="%s" src="%s" width="%s" height="%s" border=0 class="amazon"%s></a>
FORMAT
            , $tags{DetailPageURL} 
            , &main::enc( $tags{Title} )
            , split(/\t/,$tags{MediumImage}) 
            , $main::target ;
    }else{
        'Book information cannot read from amazon.co.jp.';
    }
};

# If $since has TIME and the page not modified, &http returns undef;
sub http{
    my ($host,$path,$since)=@_;

    use Socket;

    my $ip       = Socket::inet_aton($host) or die("$host not found.");
    my $port     = getservbyname('http', 'tcp');
    my $sockaddr = Socket::pack_sockaddr_in($port, $ip);
    socket(HTTP, Socket::PF_INET, Socket::SOCK_STREAM, 0) 
        or die("socket error.\n");

#     eval 'use Socket';
#     my $ip = (gethostbyname($host))[4];
#     my $sockaddr = pack("S n a4 x8" , 2 , 80 , $ip);
#     socket(HTTP, defined(Socket::PF_INET)     ? Socket::PF_INET     : 2 
#                , defined(Socket::SOCK_STREAM) ? Socket::SOCK_STREAM : 2 # or 1
#                , 0) or die("socket error.\n");

    connect(HTTP, $sockaddr);
    binmode(HTTP);
    my $output=select(HTTP); $| = 1; select($output);
    print HTTP "GET $path HTTP/1.1\r\n";
    if( defined($since) ){
        my @tm=split(/\s+/,''.gmtime($since));
        printf HTTP "If-Modified-Since: %s, %02d %s %d %s GMT\n" ,
            $tm[0],$tm[2],$tm[1],$tm[4],$tm[3] ;
    }
    print HTTP "Host: $host\r\n";
    print HTTP "Connection: close\r\n";
    print HTTP "\r\n";

    my $flag=0;
    my $body='';
    if( ( split(/\s+/,<HTTP>) )[1] eq '304' ){
        $body = undef;
    }else{
        while( defined(my $line=<HTTP>) ){
            if( $line =~ /^\r?\n?$/ ){
                while( defined(my $line=<HTTP>) ){
                    $body .= $line;
                }
                last;
            }
        }
    }
    close(HTTP);
    $body;
}

sub parse_xml{
    my ($xml,$start,$end,$text)=@_;
    $xml =~ s/\<\!\[CDATA\[(.*?)\]\]\>/"\a".unpack('h*',$1)."\a"/ges;
    while( length($xml) > 0 ){
        if( $xml =~ m|\A\</([^\<\>]+)\>|s ){ ### close tag
            $xml = $'; 
            $end->(split(/\s+/,$1)) or return;
        }elsif( $xml =~ m|\A\<([^\<\>]+)\>|s ){ ### open tag
            $xml = $'; 
            $start->( split(/\s+/,$1) ) or return;
        }elsif( $xml =~ m|\A[^\<\>]+|s ){ ### text
            $xml = $';
            my $body = $&; $body =~ s/\a(.*?)\a/pack('h*',$1)/ges;
            $text->( $body ) or return;
        }else{
            return;
        }
    }
}

1;
